

from core.himesis import Himesis, HimesisPreConditionPatternNAC
import cPickle as pickle
from uuid import UUID

class HExpandNorthNAC4(HimesisPreConditionPatternNAC):
    def __init__(self, LHS):
        """
        Creates the himesis graph representing the AToM3 model HExpandNorthNAC4.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandNorthNAC4, self).__init__(name='HExpandNorthNAC4', num_nodes=5, edges=[], LHS=LHS)
        
        # Add the edges
        self.add_edges([(2, 3), (4, 1), (1, 0), (0, 2)])
        # Set the graph attributes
        self["mm__"] = pickle.loads("""(lp1
S'MT_pre__Map'
p2
aS'MoTifRule'
p3
a.""")
        self["MT_constraint__"] = """#===============================================================================
# This code is executed after the nodes in the NAC have been matched.
# You can access a matched node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# The given constraint must evaluate to a boolean expression:
#    returning True forbids the rule from being applied,
#    returning False enables the rule to be applied.
#===============================================================================

# There doesn't already exist a road in that direction!
y = (PreNode('18')['y'] < PreNode('2')['y'])
x = (PreNode('18')['x'] == PreNode('2')['x'])
return y and x
"""
        self["name"] = """"""
        self["GUID__"] = UUID('5753c52d-f42e-4964-8df1-4cbfeb953297')
        
        # Set the node attributes
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["MT_label__"] = """19"""
        self.vs[0]["MT_pre__length"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[0]["mm__"] = """MT_pre__Road"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('32d1b5d9-6c52-4ab1-98c2-5b98348524f8')
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["MT_label__"] = """20"""
        self.vs[1]["mm__"] = """MT_pre__FromIntersection"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('558d2bb7-1e0b-42ae-8f79-88aca27a0a41')
        self.vs[2]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[2]["MT_subtypeMatching__"] = False
        self.vs[2]["MT_label__"] = """21"""
        self.vs[2]["mm__"] = """MT_pre__ToIntersection"""
        self.vs[2]["MT_dirty__"] = False
        self.vs[2]["GUID__"] = UUID('7fea806b-8630-4c31-80b3-be2dba289903')
        self.vs[3]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[3]["MT_subtypeMatching__"] = False
        self.vs[3]["MT_label__"] = """2"""
        self.vs[3]["MT_pre__x"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[3]["mm__"] = """MT_pre__Intersection"""
        self.vs[3]["MT_pre__y"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[3]["MT_dirty__"] = False
        self.vs[3]["GUID__"] = UUID('932cc433-6e1f-4515-bd5d-bee8430d3187')
        self.vs[4]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[4]["MT_subtypeMatching__"] = False
        self.vs[4]["MT_label__"] = """18"""
        self.vs[4]["MT_pre__x"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[4]["mm__"] = """MT_pre__Intersection"""
        self.vs[4]["MT_pre__y"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[4]["MT_dirty__"] = False
        self.vs[4]["GUID__"] = UUID('a806a75a-89ed-457c-9c0a-094b4dc586ac')

        
        # Load the bridge between this NAC and its LHS
        from HExpandNorthNAC4Bridge import HExpandNorthNAC4Bridge
        self.bridge = HExpandNorthNAC4Bridge()

    def eval_x2(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_y2(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_x18(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_y18(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_length19(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        #===============================================================================
        # This code is executed after the nodes in the NAC have been matched.
        # You can access a matched node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # The given constraint must evaluate to a boolean expression:
        #    returning True forbids the rule from being applied,
        #    returning False enables the rule to be applied.
        #===============================================================================
        
        # There doesn't already exist a road in that direction!
        y = (PreNode('18')['y'] < PreNode('2')['y'])
        x = (PreNode('18')['x'] == PreNode('2')['x'])
        return y and x

