

from core.himesis import Himesis, HimesisPreConditionPatternNAC
import cPickle as pickle
from uuid import UUID

class HExpandSouthNAC1(HimesisPreConditionPatternNAC):
    def __init__(self, LHS):
        """
        Creates the himesis graph representing the AToM3 model HExpandSouthNAC1.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandSouthNAC1, self).__init__(name='HExpandSouthNAC1', num_nodes=6, edges=[], LHS=LHS)
        
        # Add the edges
        self.add_edges([(4, 1), (2, 5), (1, 0), (0, 2)])
        # Set the graph attributes
        self["mm__"] = pickle.loads("""(lp1
S'MT_pre__Map'
p2
aS'MoTifRule'
p3
a.""")
        self["MT_constraint__"] = """#===============================================================================
# This code is executed after the nodes in the NAC have been matched.
# You can access a matched node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# The given constraint must evaluate to a boolean expression:
#    returning True forbids the rule from being applied,
#    returning False enables the rule to be applied.
#===============================================================================

# Determine the direction of the existing road:
x = abs(PreNode('4')['x'] - PreNode('5')['x'])
y = abs(PreNode('4')['y'] - PreNode('5')['y'])

# If it is in the same direction: skip because we should have found the
# intersections if they crossed.
if x == 0:
 return False

# Check for an overlap: this means that the intersections lie at different sides of the newly created road.
xmin = min(PreNode('4')['x'], PreNode('5')['x'])
xmax = max(PreNode('4')['x'], PreNode('5')['x'])

ymin = PreNode('2')['y'] - 7
ymax = PreNode('2')['y'] + 18

if xmin < PreNode('2')['x'] and xmax > PreNode('2')['x']:
 if ymin < PreNode('4')['y'] and PreNode('4')['y'] < ymax:
  return True

return False
"""
        self["name"] = """"""
        self["GUID__"] = UUID('dc26ae6d-73e4-4c16-8a4d-9684ba9b3fcd')
        
        # Set the node attributes
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["MT_label__"] = """6"""
        self.vs[0]["MT_pre__length"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[0]["mm__"] = """MT_pre__Road"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('a894a21e-44ec-4d9c-a6a7-aee8bb43c872')
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["MT_label__"] = """7"""
        self.vs[1]["mm__"] = """MT_pre__FromIntersection"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('b01119a1-cf95-40ea-8a53-50ecdda405e1')
        self.vs[2]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[2]["MT_subtypeMatching__"] = False
        self.vs[2]["MT_label__"] = """8"""
        self.vs[2]["mm__"] = """MT_pre__ToIntersection"""
        self.vs[2]["MT_dirty__"] = False
        self.vs[2]["GUID__"] = UUID('df313ef5-5795-44ee-b6f6-83dacfed69a6')
        self.vs[3]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[3]["MT_subtypeMatching__"] = False
        self.vs[3]["MT_label__"] = """2"""
        self.vs[3]["MT_pre__x"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[3]["mm__"] = """MT_pre__Intersection"""
        self.vs[3]["MT_pre__y"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[3]["MT_dirty__"] = False
        self.vs[3]["GUID__"] = UUID('47359144-db26-4cf1-b230-dd8fd7b5330c')
        self.vs[4]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[4]["MT_subtypeMatching__"] = False
        self.vs[4]["MT_label__"] = """4"""
        self.vs[4]["MT_pre__x"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[4]["mm__"] = """MT_pre__Intersection"""
        self.vs[4]["MT_pre__y"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[4]["MT_dirty__"] = False
        self.vs[4]["GUID__"] = UUID('dfd7c0ad-c0b8-4417-b147-774ff5180f82')
        self.vs[5]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[5]["MT_subtypeMatching__"] = False
        self.vs[5]["MT_label__"] = """5"""
        self.vs[5]["MT_pre__x"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[5]["mm__"] = """MT_pre__Intersection"""
        self.vs[5]["MT_pre__y"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[5]["MT_dirty__"] = False
        self.vs[5]["GUID__"] = UUID('b603954f-30f6-4321-ac2d-8b5e2160398e')

        
        # Load the bridge between this NAC and its LHS
        from HExpandSouthNAC1Bridge import HExpandSouthNAC1Bridge
        self.bridge = HExpandSouthNAC1Bridge()

    def eval_x2(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_y2(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_x4(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_y4(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_x5(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_y5(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_length6(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        #===============================================================================
        # This code is executed after the nodes in the NAC have been matched.
        # You can access a matched node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # The given constraint must evaluate to a boolean expression:
        #    returning True forbids the rule from being applied,
        #    returning False enables the rule to be applied.
        #===============================================================================
        
        # Determine the direction of the existing road:
        x = abs(PreNode('4')['x'] - PreNode('5')['x'])
        y = abs(PreNode('4')['y'] - PreNode('5')['y'])
        
        # If it is in the same direction: skip because we should have found the
        # intersections if they crossed.
        if x == 0:
         return False
        
        # Check for an overlap: this means that the intersections lie at different sides of the newly created road.
        xmin = min(PreNode('4')['x'], PreNode('5')['x'])
        xmax = max(PreNode('4')['x'], PreNode('5')['x'])
        
        ymin = PreNode('2')['y'] - 7
        ymax = PreNode('2')['y'] + 18
        
        if xmin < PreNode('2')['x'] and xmax > PreNode('2')['x']:
         if ymin < PreNode('4')['y'] and PreNode('4')['y'] < ymax:
          return True
        
        return False

