

from core.himesis import Himesis, HimesisPreConditionPatternLHS
import cPickle as pickle
from uuid import UUID

class HGrowRoadLHS(HimesisPreConditionPatternLHS):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HGrowRoadLHS.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HGrowRoadLHS, self).__init__(name='HGrowRoadLHS', num_nodes=8, edges=[])
        
        # Add the edges
        self.add_edges([(7, 2), (2, 4), (6, 3), (3, 5), (4, 1), (5, 1), (1, 6), (1, 7)])
        # Set the graph attributes
        self["mm__"] = pickle.loads("""(lp1
S'MT_pre__Map'
p2
aS'MoTifRule'
p3
a.""")
        self["MT_constraint__"] = """#===============================================================================
# This code is executed after the nodes in the LHS have been matched.
# You can access a matched node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# The given constraint must evaluate to a boolean expression:
#    returning True enables the rule to be applied,
#    returning False forbids the rule from being applied.
#===============================================================================

# There must be enough room to grow the road.
x = PreNode('4')['x'] - PreNode('2')['x']
y = PreNode('4')['y'] - PreNode('2')['y']

if abs(x) == 0:
 # We will expand in the y direction
 if y < 0:
  # Going North!
  return PreNode('4')['y'] >= 4
 elif y > 0:
  # Going South!
  return PreNode('4')['y'] <= PreNode('1')['size'] - 4

elif abs(y) == 0:
 # We will expand in the x direction
 if x < 0:
  # Going West!
  return PreNode('4')['x'] >= 4
 elif x > 0:
  # Going East!
  return PreNode('4')['x'] <= PreNode('1')['size'] - 4
"""
        self["name"] = """"""
        self["GUID__"] = UUID('2488cd2d-6b59-4de8-8093-12fe432b70ed')
        
        # Set the node attributes
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["MT_pre__size"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[0]["MT_pre__remaining"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return attr_value >= 1
"""
        self.vs[0]["MT_label__"] = """1"""
        self.vs[0]["mm__"] = """MT_pre__MapInformation"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('8eb0e46f-1ebe-4aa0-ab70-61fca494216a')
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["MT_label__"] = """3"""
        self.vs[1]["MT_pre__length"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[1]["mm__"] = """MT_pre__Road"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('2965dc36-8b15-4c47-bd87-bacd03d73d36')
        self.vs[2]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[2]["MT_subtypeMatching__"] = False
        self.vs[2]["MT_label__"] = """2"""
        self.vs[2]["MT_pre__x"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[2]["mm__"] = """MT_pre__Intersection"""
        self.vs[2]["MT_pre__y"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[2]["MT_dirty__"] = False
        self.vs[2]["GUID__"] = UUID('06a4c081-bbce-4027-b6a3-a76786881130')
        self.vs[3]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[3]["MT_subtypeMatching__"] = False
        self.vs[3]["MT_label__"] = """4"""
        self.vs[3]["MT_pre__x"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[3]["mm__"] = """MT_pre__Intersection"""
        self.vs[3]["MT_pre__y"] = """
#===============================================================================
# This code is executed when evaluating if a node shall be matched by this rule.
# You can access the value of the current node's attribute value by: attr_value.
# You can access any attribute x of this node by: this['x'].
# If the constraint relies on attribute values from other nodes,
# use the LHS/NAC constraint instead.
# The given constraint must evaluate to a boolean expression.
#===============================================================================

return True
"""
        self.vs[3]["MT_dirty__"] = False
        self.vs[3]["GUID__"] = UUID('d24da573-a591-4162-b178-2a3dc2f9373e')
        self.vs[4]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[4]["MT_subtypeMatching__"] = False
        self.vs[4]["MT_label__"] = """5"""
        self.vs[4]["mm__"] = """MT_pre__FromIntersection"""
        self.vs[4]["MT_dirty__"] = False
        self.vs[4]["GUID__"] = UUID('32e8b86d-24fc-4b12-bd44-9294ffeb64c1')
        self.vs[5]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[5]["MT_subtypeMatching__"] = False
        self.vs[5]["MT_label__"] = """7"""
        self.vs[5]["mm__"] = """MT_pre__FromIntersection"""
        self.vs[5]["MT_dirty__"] = False
        self.vs[5]["GUID__"] = UUID('b75484a8-7bb7-4826-b77d-c9fca9737a4a')
        self.vs[6]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[6]["MT_subtypeMatching__"] = False
        self.vs[6]["MT_label__"] = """6"""
        self.vs[6]["mm__"] = """MT_pre__ToIntersection"""
        self.vs[6]["MT_dirty__"] = False
        self.vs[6]["GUID__"] = UUID('7e0d06f5-79e0-4ef9-831e-c570b7c2f722')
        self.vs[7]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[7]["MT_subtypeMatching__"] = False
        self.vs[7]["MT_label__"] = """8"""
        self.vs[7]["mm__"] = """MT_pre__ToIntersection"""
        self.vs[7]["MT_dirty__"] = False
        self.vs[7]["GUID__"] = UUID('fc4b54eb-6f13-4a3d-a641-1065831e4325')

        
        # Load the NACs
        from HGrowRoadNAC0 import HGrowRoadNAC0
        from HGrowRoadNAC1 import HGrowRoadNAC1
        from HGrowRoadNAC2 import HGrowRoadNAC2
        from HGrowRoadNAC3 import HGrowRoadNAC3
        from HGrowRoadNAC4 import HGrowRoadNAC4
        self.NACs = [HGrowRoadNAC0(LHS=self), HGrowRoadNAC1(LHS=self), HGrowRoadNAC2(LHS=self), HGrowRoadNAC3(LHS=self), HGrowRoadNAC4(LHS=self)]

    def eval_x2(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_y2(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_x4(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_y4(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_size1(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def eval_remaining1(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return attr_value >= 1


    def eval_length3(self, attr_value, this):
        
        #===============================================================================
        # This code is executed when evaluating if a node shall be matched by this rule.
        # You can access the value of the current node's attribute value by: attr_value.
        # You can access any attribute x of this node by: this['x'].
        # If the constraint relies on attribute values from other nodes,
        # use the LHS/NAC constraint instead.
        # The given constraint must evaluate to a boolean expression.
        #===============================================================================
        
        return True


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        #===============================================================================
        # This code is executed after the nodes in the LHS have been matched.
        # You can access a matched node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # The given constraint must evaluate to a boolean expression:
        #    returning True enables the rule to be applied,
        #    returning False forbids the rule from being applied.
        #===============================================================================
        
        # There must be enough room to grow the road.
        x = PreNode('4')['x'] - PreNode('2')['x']
        y = PreNode('4')['y'] - PreNode('2')['y']
        
        if abs(x) == 0:
         # We will expand in the y direction
         if y < 0:
          # Going North!
          return PreNode('4')['y'] >= 4
         elif y > 0:
          # Going South!
          return PreNode('4')['y'] <= PreNode('1')['size'] - 4
        
        elif abs(y) == 0:
         # We will expand in the x direction
         if x < 0:
          # Going West!
          return PreNode('4')['x'] >= 4
         elif x > 0:
          # Going East!
          return PreNode('4')['x'] <= PreNode('1')['size'] - 4

