

from core.himesis import Himesis, HimesisPostConditionPattern
import cPickle as pickle
from uuid import UUID

class HGrowRoadRHS(HimesisPostConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HGrowRoadRHS.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HGrowRoadRHS, self).__init__(name='HGrowRoadRHS', num_nodes=8, edges=[])
        
        # Add the edges
        self.add_edges([(6, 2), (2, 0), (7, 3), (3, 0), (0, 4), (4, 7), (0, 5), (5, 6)])
        # Set the graph attributes
        self["mm__"] = pickle.loads("""(lp1
S'MT_post__Map'
p2
aS'MoTifRule'
p3
a.""")
        self["MT_action__"] = """#===============================================================================
# This code is executed after the rule has been applied.
# You can access a node labelled n matched by this rule by: PostNode('n').
# To access attribute x of node n, use: PostNode('n')['x'].
#===============================================================================

pass
"""
        self["name"] = """"""
        self["GUID__"] = UUID('10577986-4f24-4db2-95c8-b35ad8b9ba78')
        
        # Set the node attributes
        self.vs[0]["MT_label__"] = """3"""
        self.vs[0]["MT_post__length"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value + 1
"""
        self.vs[0]["mm__"] = """MT_post__Road"""
        self.vs[0]["GUID__"] = UUID('935fc166-9a57-40a5-b03a-c874987aa23c')
        self.vs[1]["MT_post__remaining"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value - 1
"""
        self.vs[1]["MT_label__"] = """1"""
        self.vs[1]["mm__"] = """MT_post__MapInformation"""
        self.vs[1]["MT_post__size"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[1]["GUID__"] = UUID('da6a3e8c-37ee-4e2a-845f-988ef378e702')
        self.vs[2]["MT_label__"] = """5"""
        self.vs[2]["mm__"] = """MT_post__FromIntersection"""
        self.vs[2]["GUID__"] = UUID('1bfc3bb5-3cf5-487f-ab02-eefd89a474e4')
        self.vs[3]["MT_label__"] = """7"""
        self.vs[3]["mm__"] = """MT_post__FromIntersection"""
        self.vs[3]["GUID__"] = UUID('91d19727-7ce5-4202-b726-59a5c5d11cdd')
        self.vs[4]["MT_label__"] = """6"""
        self.vs[4]["mm__"] = """MT_post__ToIntersection"""
        self.vs[4]["GUID__"] = UUID('0d9ef03f-cb49-4414-8686-01b6e1696951')
        self.vs[5]["MT_label__"] = """8"""
        self.vs[5]["mm__"] = """MT_post__ToIntersection"""
        self.vs[5]["GUID__"] = UUID('268cda13-72b6-4bd0-b641-b61aae8f1e51')
        self.vs[6]["MT_label__"] = """2"""
        self.vs[6]["MT_post__x"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[6]["mm__"] = """MT_post__Intersection"""
        self.vs[6]["MT_post__y"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[6]["GUID__"] = UUID('831ddcc2-3c26-4b8f-853b-7cf2c48847c0')
        self.vs[7]["MT_label__"] = """4"""
        self.vs[7]["MT_post__x"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

# If there is a difference between the intersections in the x direction, it shall be increased by 1.

x = PreNode('4')['x'] - PreNode('2')['x']

if abs(x) != 0:
 if x < 0:
  # Going West!
  return attr_value - 1
 elif x > 0:
  # Going East!
  return attr_value + 1
else:
 return attr_value
"""
        self.vs[7]["mm__"] = """MT_post__Intersection"""
        self.vs[7]["MT_post__y"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

# If there is a difference between the intersections in the x direction, it shall be increased by 1.

y = PreNode('4')['y'] - PreNode('2')['y']

if abs(y) != 0:
 if y < 0:
  # Going North!
  return attr_value - 1
 elif y > 0:
  # Going South!
  return attr_value + 1
else:
 return attr_value
"""
        self.vs[7]["GUID__"] = UUID('1a57b7fc-5b88-462a-bdd1-e908bd25a5f1')

        from HGrowRoadLHS import HGrowRoadLHS
        self.pre = HGrowRoadLHS()
    
    def set_x4(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        # If there is a difference between the intersections in the x direction, it shall be increased by 1.
        
        x = PreNode('4')['x'] - PreNode('2')['x']
        
        if abs(x) != 0:
         if x < 0:
          # Going West!
          return attr_value - 1
         elif x > 0:
          # Going East!
          return attr_value + 1
        else:
         return attr_value


    def set_y4(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        # If there is a difference between the intersections in the x direction, it shall be increased by 1.
        
        y = PreNode('4')['y'] - PreNode('2')['y']
        
        if abs(y) != 0:
         if y < 0:
          # Going North!
          return attr_value - 1
         elif y > 0:
          # Going South!
          return attr_value + 1
        else:
         return attr_value


    def set_length3(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        return attr_value + 1


    def set_remaining1(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        return attr_value - 1


    def action(self, PostNode, graph):
        """
            Executable constraint code. 
            @param PostNode: Function taking an integer as parameter
                             and returns the node corresponding to that label.
        """
        #===============================================================================
        # This code is executed after the rule has been applied.
        # You can access a node labelled n matched by this rule by: PostNode('n').
        # To access attribute x of node n, use: PostNode('n')['x'].
        #===============================================================================
        
        pass

    def execute(self, packet, match):
        """
            Transforms the current match of the packet according to the rule %s.
            Pivots are also assigned, if any.
            @param packet: The input packet.
            @param match: The match to rewrite.
        """
        graph = packet.graph
        
        # Build a dictionary {label: node index} mapping each label of the pattern to a node in the graph to rewrite.
        # Because of the uniqueness property of labels in a rule, we can store all LHS labels
        # and subsequently add the labels corresponding to the nodes to be created.
        labels = match.copy()
        
        #===============================================================================
        # Update attribute values
        #===============================================================================
        # MapInformation1
        try:
            graph.vs[labels['1']]['remaining'] = self.set_remaining1(graph.vs[labels['1']]['remaining'], lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'remaining\'', e)
        
        graph.vs[labels['1']][Himesis.Constants.MT_DIRTY] = True
        # Road3
        try:
            graph.vs[labels['3']]['length'] = self.set_length3(graph.vs[labels['3']]['length'], lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'length\'', e)
        
        graph.vs[labels['3']][Himesis.Constants.MT_DIRTY] = True
        # Intersection4
        try:
            graph.vs[labels['4']]['x'] = self.set_x4(graph.vs[labels['4']]['x'], lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'x\'', e)
        try:
            graph.vs[labels['4']]['y'] = self.set_y4(graph.vs[labels['4']]['y'], lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'y\'', e)
        
        graph.vs[labels['4']][Himesis.Constants.MT_DIRTY] = True
        
        #===============================================================================
        # Create new nodes
        #===============================================================================
        
        #===============================================================================
        # Create new edges
        #===============================================================================
        
        #===============================================================================
        # Set the output pivots
        #===============================================================================
        
        #===============================================================================
        # Perform the post-action
        #===============================================================================
        try:
            self.action(lambda i: graph.vs[labels[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while applying the post-action', e)
        #===============================================================================
        # Finally, delete nodes (this will automatically delete the adjacent edges)
        #===============================================================================
    
