
from t_core.composer import Composer
from util.seeded_random import Random


class UniqueLayer(Composer):
    '''
        Applies each rule once in a non-deterministic order.
    '''
    def __init__(self, rules):
        '''
            Applies each rule once in a non-deterministic order.
            @param rules: The rules to apply.
        '''
        super(UniqueLayer, self).__init__()
        self.rules = rules
    
    def packet_in(self, packet):
        self.exception = None
        self.is_success = False
        while len(self.rules) > 0:
            rule = self.rules.pop(Random.randint(0, len(self.rules) - 1))
            packet = rule.packet_in(packet)
            if rule.is_success:
                self.is_success = True
            else:
                if rule.exception is not None:
                    self.exception = rule.exception
                    return packet
        return packet
